/*
 *  test wind_xget(WF_FIRSTXYWH)
 * 
 */

#include <stdlib.h>
#include <windom.h>
#include <windom/dfrm.h>

int use_wind_xget = 0;
short ind_yes, ind_no;  /* index of button YES and NO */


/* defines the content of the main data (5 rectangles) */
typedef struct {
	GRECT left, up, down, right, center;
	short color_index;
} WINDATA;

static void draw_motif ( short vdih, const GRECT *r, short color) {
	short pxy[4];
	short count;
	short wcur, hcur;
	
	vsl_width( vdih, 1);
	vsl_color( vdih, color);

	vswr_mode( vdih, MD_REPLACE);
	grect_to_array( r, pxy);
	v_bar( vdih, pxy);
	
	vswr_mode( vdih, MD_TRANS);
	vsf_perimeter( vdih, PERIMETER_ON);

#if 1
	pxy[0] = r->g_x + 1;
	pxy[1] = r->g_y + 1;
	wcur = r->g_w - 2;
	hcur = r->g_h - 2;
	
	vsm_color( vdih, color);
	
	while (wcur > 0 && hcur > 0) {
		for (count=wcur; count>0; count--) {
			pxy[0]++;
			v_pmarker( vdih, 1, pxy);
		}
		for (count=hcur; count>0; count--) {
			pxy[1]++;
			v_pmarker( vdih, 1, pxy);
		}
		for (count=wcur; count>0; count--) {
			pxy[0]--;
			v_pmarker( vdih, 1, pxy);
		}
		for (count=hcur-1; count>0; count--) {
			pxy[1]--;
			v_pmarker( vdih, 1, pxy);
		}
		wcur -= 2;
		hcur -= 2;
	}
#endif

#if 0	
	pxy[0] = r->g_x + 1;
	pxy[1] = r->g_y + 1;
	pxy[2] = r->g_x + r->g_w - 2;
	pxy[3] = r->g_y + r->g_h - 2;
	vsl_color( vdih, color+1);
	for (count = r->g_w - 2; count >= 0; count--) {
		v_pline( vdih, 2, pxy);
		pxy[0]++;
		pxy[2]--;
	}
	vsl_color( vdih, color+2);
	for (count = r->g_h - 2; count >= 0; count--) {
		v_pline( vdih, 2, pxy);
		pxy[1]++;
		pxy[3]--;
	}
#endif
	
}

/* callback function invoked on WM_REDRAW message for the main window */
static void __CDECL draw ( WINDOW *win, void *_data) {
	WINDATA *windata = (WINDATA*) _data;
	short x, y, w, h;
	GRECT rect;
	
	vswr_mode( win->graf.handle, MD_REPLACE);
	WindClear(win);

	WindGet( win, WF_WORKXYWH, &x, &y, &w, &h);
	
	rect = windata->left;
	rect.g_x += x; rect.g_y += y;
	draw_motif( win->graf.handle, &rect, windata->color_index);
	
	rect = windata->up;
	rect.g_x += x; rect.g_y += y;
	draw_motif( win->graf.handle, &rect, windata->color_index);
	
	rect = windata->right;
	rect.g_x += x; rect.g_y += y;
	draw_motif( win->graf.handle, &rect, windata->color_index);
	
	rect = windata->down;
	rect.g_x += x; rect.g_y += y;
	draw_motif( win->graf.handle, &rect, windata->color_index);
	
	rect = windata->center;
	rect.g_x += x; rect.g_y += y;
	draw_motif( win->graf.handle, &rect, windata->color_index);
	
}

static void update_one_object( WINDOW *win, const GRECT *rect, short color_index) {
	GRECT aesr;
	
	if (use_wind_xget == ind_yes)
		wind_xget_grect( win->handle, WF_FIRSTXYWH, rect, &aesr);
	else
		wind_get_grect( win->handle, WF_FIRSTXYWH, &aesr);
	while (aesr.g_w && aesr.g_h) {
		if ( rc_intersect(rect, &aesr) ) {
			ClipOn( win, &aesr);
			draw_motif( win->graf.handle, rect, color_index);
			ClipOff( win);
		}
		wind_get_grect( win->handle, WF_NEXTXYWH, &aesr);
	}
}

/* when a timer event is triggered, this function is called */
static void __CDECL timer( WINDOW *win, void *_data) {
	WINDATA *windata = (WINDATA*) _data;
	short x, y, w, h;
	GRECT rect;
	
	windata->color_index++;
	if (windata->color_index > 15) windata->color_index = 0;
	
	WindGet( win, WF_WORKXYWH, &x, &y, &w, &h);
	
	while( !wind_update(BEG_UPDATE));
	graf_mouse( M_OFF, 0L);
		
	rect = windata->left;
	rect.g_x += x; rect.g_y += y;
	update_one_object( win, &rect, windata->color_index);
		
	rect = windata->up;
	rect.g_x += x; rect.g_y += y;
	update_one_object( win, &rect, windata->color_index);
	
	rect = windata->right;
	rect.g_x += x; rect.g_y += y;
	update_one_object( win, &rect, windata->color_index);
	
	rect = windata->down;
	rect.g_x += x; rect.g_y += y;
	update_one_object( win, &rect, windata->color_index);
	
	rect = windata->center;
	rect.g_x += x; rect.g_y += y;
	update_one_object( win, &rect, windata->color_index);
	
	graf_mouse( M_ON, 0L);
	wind_update(END_UPDATE);
}

/* creation of an empty window */
static void create_empty_window( const GRECT *r) {
	WINDOW *win;
	
	win = WindCreate(MOVER|NAME|CLOSER, app.x, app.y, app.w, app.h);
	WindOpen( win, r->g_x, r->g_y, r->g_w, r->g_h);
	
}

/* creation of the main window */
static void create_main_window( const GRECT *r) {
	WINDOW *win;
	static WINDATA windata;
	GRECT winrect;
	
	/* compute the position and the size of the 5 filled objects */
	windata.left.g_x = 4;
	windata.up.g_x = windata.center.g_x = windata.down.g_x = r->g_w / 3 + 4;
	windata.right.g_x = (2 * r->g_w) / 3 + 4;
	windata.up.g_y = 4;
	windata.left.g_y = windata.center.g_y = windata.right.g_y = r->g_h / 3 + 4;
	windata.down.g_y = (2 * r->g_h) / 3 + 4;
	windata.left.g_w = windata.up.g_w = windata.center.g_w = windata.down.g_w = windata.right.g_w = r->g_w / 3 - 8;
	windata.left.g_h = windata.up.g_h = windata.center.g_h = windata.down.g_h = windata.right.g_h = r->g_h / 3 - 8;
	windata.color_index = 2;
	
	win = WindCreate(MOVER|NAME|CLOSER, app.x, app.y, app.w, app.h);
	EvntDataAttach( win, WM_XTIMER, timer, &windata);
	EvntDataAttach( win, WM_REDRAW, draw, &windata);
	
	WindCalc( WC_BORDER, win, r->g_x, r->g_y, r->g_w, r->g_h, &winrect.g_x, &winrect.g_y, &winrect.g_w, &winrect.g_h);
	WindOpen( win, winrect.g_x, winrect.g_y, winrect.g_w, winrect.g_h);
}

/* creation of the formular */
static void __CDECL free_dynamical_form( WINDOW *win, void *dfrm)
{
        OBJECT *tree;

        tree = dfrm_tree( dfrm);
//        RsrcXtype( 0,  &tree, 1);
        dfrm_free( dfrm);
}

/* creation of the formular */
static void create_form_window( const GRECT *r) {
	void *dfrm;
	WINDOW *win;
	OBJECT *tree;
	short ind;
	GRECT pos;
	
	dfrm = dfrm_create( 10, TYPE_NORMAL);
	
	ind = dfrm_new_label( dfrm, TYPE_LABEL, "use wind_xget(WF_FIRSTXYWH):");
	dfrm_add( dfrm, ROOT, ind, -2, -2, DIR_HORI);
	
	ind = dfrm_new_button( dfrm, TYPE_RBUT, "YES");
	dfrm_add( dfrm, ROOT, ind, -2, -2, DIR_HORI);
	ind_yes = ind;
	
	ind = dfrm_new_button( dfrm, TYPE_RBUT, "NO");
	dfrm_add( dfrm, ROOT, ind, -2, -2, DIR_HORI);
	ind_no = ind;
	
	dfrm_repack( dfrm);
	tree = dfrm_tree( dfrm);
	
	WindCalc( WC_BORDER, win, r->g_x, r->g_y, tree->ob_width, tree->ob_height, &pos.g_x, &pos.g_y, &pos.g_w, &pos.g_h);
	pos.g_x = r->g_x;
	pos.g_y = r->g_y;
	
	win = FormCreate( tree, WAT_FORM, NULL, "dynamical formular", &pos, 0, 0);
	dfrm_win_attach( OC_FORM, win, dfrm);
	
	EvntDataAdd( win, WM_DESTROY, free_dynamical_form, dfrm, EV_TOP);
	
	ObjcAttach( OC_FORM, win, ind_yes, BIND_VAR, &use_wind_xget);
	ObjcAttach( OC_FORM, win, ind_no,  BIND_VAR, &use_wind_xget);
	
	if (use_wind_xget) {
		tree[ind_yes].ob_state  |= SELECTED;
		tree[ind_no].ob_state &= ~SELECTED;
		use_wind_xget = ind_yes;
	} else {
		tree[ind_no].ob_state  |= SELECTED;
		tree[ind_yes].ob_state &= ~SELECTED;
		use_wind_xget = ind_no;
	}
}


/* creation of empty window */

int main( void) {
	GRECT desk;
	GRECT topleft, topright, downleft, downright, center;
	
	ApplInit();
	
	/* compute area of windows */
	wind_get_grect( 0, WF_CURRXYWH, &desk);
	center.g_x = desk.g_x + 50;
	center.g_y = desk.g_y + 50;
	center.g_w = desk.g_w - 100;
	center.g_h = desk.g_h - 100;
	topleft.g_x = desk.g_x + 25;
	topleft.g_y = desk.g_y + 25;
	topleft.g_w = 25 + ( 4 * center.g_w) / 9;  /* right border at 4/9 of left of center win */
	topleft.g_h = 25 + ( 1 * center.g_h) / 6;  /* down border at 1/6 of top of center win */
	topright.g_x = center.g_x + ( 5 * center.g_w) / 6 ; /* left border at 5/6 of left of center win */
	topright.g_y = 25;
	topright.g_w = desk.g_w - (topright.g_x - desk.g_x) - 25;
	topright.g_h = 25 + ( 4 * center.g_h) / 9; /* down border at 4/9 of top of center win */
	downleft.g_x = desk.g_x + 25;
	downleft.g_y = center.g_y + ( 5 * center.g_h) / 9; /* top border at 5/9 of top of center win */
	downleft.g_w = 25 + ( 1 * center.g_w) / 6;  /* right border at 1/6 of left of center win */
	downleft.g_h = desk.g_h - (downleft.g_y - desk.g_y) - 25;
	downright.g_x = center.g_x + ( 5 * center.g_w) / 9;  /* left border at 5/9 of left of center win */
	downright.g_y = center.g_y + ( 5 * center.g_h) / 6; /* top border at 5/6 of top of center win */
	downright.g_w = 0; /* automatically computer to fit the formular */
	downright.g_h = 0; /* automatically computer to fit the formular */
	
	/* create windows (from bottom win to top win) */
	create_main_window( &center);
	create_empty_window( &topleft);
	create_empty_window( &topright);
	create_empty_window( &downleft);
	create_form_window ( &downright);
	
	evnt.timer = 2000L;
	while (wglb.first) {
		EvntWindom(MU_MESAG | MU_TIMER);
	}
	
	ApplExit();
}
